---
name: Bug report
about: Create a report to help us improve

---

## Problem/Motivation

> (Why the issue was filed)

## Expected behaviour

> (What you expected to happen)

## Actual behaviour

> (What actually happened)

## Steps to reproduce

> (How can someone else make/see it happen)
>
> (Please include any relevant links. Think: links to a branch in a repo where you are experiencing the problem
> which can be used to reproduce the issue, links to external standards you are using.)
> (Also, if relevant and if it can be used to reproduce the issue, please paste the contents of your `composer.json`
> file here.
>
> ```json
> (Content of the `composer.json` file)
> ```

## Proposed changes

> (If you have a proposed change, workaround or fix, describe the rationale behind it)

## Environment

| Question               | Answer
| ------------------------| -------
| OS                                | Windows/Linux/Mac (preferably with some version info)
| PHP version                       | x.y.z
| Composer version                  | x.y.z
| PHP_CodeSniffer version           | x.y.z
| Dealerdirect PHPCS plugin version | x.y.z
| Install type                      | e.g. Composer global, Composer project local, other (please expand)

Output of `vendor/bin/phpcs --config-show`:
```
(Please paste the output you get here)
```

## Tested against `master` branch?
- [ ] I have verified the issue still exists in the `master` branch.
